# _*_ coding: iso-8859-1 _*_
#Boa:FramePanel:BlocReseau
##iso-8859-1
import wx

import fonctions, option, sys, os

from pbgest import CliPB
C = CliPB()
getrootobject, disconnect = C.getrootobject, C.disconnect

[wxID_BLOCRESEAU, wxID_BLOCRESEAUBLOCBTN, wxID_BLOCRESEAUCHOICEENDBLOC, 
 wxID_BLOCRESEAUCHOICEGRP, wxID_BLOCRESEAUCHOICETYPEBLOC, 
 wxID_BLOCRESEAULISTCTRLUSERS, wxID_BLOCRESEAURADIOBTN0, 
 wxID_BLOCRESEAURADIOBTN1, wxID_BLOCRESEAURADIOBTN2, 
 wxID_BLOCRESEAUSTATICTEXTBLOC, wxID_BLOCRESEAUSTATICTEXTFIN, 
 wxID_BLOCRESEAUSTATICTEXTGRP, wxID_BLOCRESEAUSTATICTEXTLECT, 
] = [wx.NewId() for _init_ctrls in range(13)]

class BlocReseau(wx.Panel):
    def _init_coll_listCtrlUsers_Columns(self, parent):
        # generated method, don't edit

        parent.InsertColumn(col=0, format=wx.LIST_FORMAT_LEFT,
              heading='El\xe8ves', width=130)
        parent.InsertColumn(col=1, format=wx.LIST_FORMAT_LEFT,
              heading='Type de blocage', width=100)
        parent.InsertColumn(col=2, format=wx.LIST_FORMAT_LEFT,
              heading='Partages', width=280)

    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wx.Panel.__init__(self, id=wxID_BLOCRESEAU, name='BlocReseau',
              parent=prnt, pos=wx.Point(360, 340), size=wx.Size(740, 420),
              style=wx.TAB_TRAVERSAL)
        self.SetClientSize(wx.Size(732, 386))
        self.SetBackgroundColour(wx.Colour(255, 255, 209))
        self.SetBackgroundStyle(wx.BG_STYLE_COLOUR)

        self.staticTextGrp = wx.StaticText(id=wxID_BLOCRESEAUSTATICTEXTGRP,
              label='Liste des groupes', name='staticTextGrp', parent=self,
              pos=wx.Point(150, 10), size=wx.Size(115, 16), style=0)
        self.staticTextGrp.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD,
              False, 'Tahoma'))

        self.staticTextBloc = wx.StaticText(id=wxID_BLOCRESEAUSTATICTEXTBLOC,
              label='Type de blocage', name='staticTextBloc', parent=self,
              pos=wx.Point(488, 76), size=wx.Size(105, 16), style=0)
        self.staticTextBloc.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD,
              False, 'Tahoma'))

        self.staticTextFin = wx.StaticText(id=wxID_BLOCRESEAUSTATICTEXTFIN,
              label='Fin du blocage', name='staticTextFin', parent=self,
              pos=wx.Point(488, 272), size=wx.Size(91, 16), style=0)
        self.staticTextFin.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD,
              False, 'Tahoma'))

        self.choiceGrp = wx.Choice(choices=[], id=wxID_BLOCRESEAUCHOICEGRP,
              name='choiceGrp', parent=self, pos=wx.Point(104, 34),
              size=wx.Size(192, 24), style=0)
        self.choiceGrp.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.NORMAL,
              False, 'Tahoma'))
        self.choiceGrp.Bind(wx.EVT_CHOICE, self.OnChoiceGrpChoice,
              id=wxID_BLOCRESEAUCHOICEGRP)

        self.listCtrlUsers = wx.ListCtrl(id=wxID_BLOCRESEAULISTCTRLUSERS,
              name='listCtrlUsers', parent=self, pos=wx.Point(26, 76),
              size=wx.Size(350, 244), style=wx.LC_REPORT)
        self._init_coll_listCtrlUsers_Columns(self.listCtrlUsers)

        self.choiceTypeBloc = wx.Choice(choices=[],
              id=wxID_BLOCRESEAUCHOICETYPEBLOC, name='choiceTypeBloc',
              parent=self, pos=wx.Point(416, 100), size=wx.Size(248, 24),
              style=0)
        self.choiceTypeBloc.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.NORMAL,
              False, 'Tahoma'))

        self.radioBtn0 = wx.RadioButton(id=wxID_BLOCRESEAURADIOBTN0,
              label='Normaux', name='radioBtn0', parent=self,
              pos=wx.Point(416, 184), size=wx.Size(81, 13), style=wx.RB_GROUP)
        self.radioBtn0.SetValue(True)

        self.radioBtn1 = wx.RadioButton(id=wxID_BLOCRESEAURADIOBTN1,
              label='Aucun lecteur', name='radioBtn1',
              parent=self, pos=wx.Point(416, 208), size=wx.Size(152, 13),
              style=0)
        self.radioBtn1.SetValue(False)

        self.radioBtn2 = wx.RadioButton(id=wxID_BLOCRESEAURADIOBTN2,
              label='Seulement le partage "devoirs"',
              name='radioBtn2', parent=self, pos=wx.Point(416, 232),
              size=wx.Size(280, 13), style=0)
        self.radioBtn2.SetValue(False)

        self.choiceEndBloc = wx.Choice(choices=[],
              id=wxID_BLOCRESEAUCHOICEENDBLOC, name='choiceEndBloc',
              parent=self, pos=wx.Point(416, 296), size=wx.Size(248, 24),
              style=0)
        self.choiceEndBloc.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.NORMAL,
              False, 'Tahoma'))

        self.blocBtn = wx.Button(id=wxID_BLOCRESEAUBLOCBTN,
              label='Appliquer le blocage', name='blocBtn', parent=self,
              pos=wx.Point(304, 344), size=wx.Size(136, 24), style=0)
        self.blocBtn.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.NORMAL, False,
              'Tahoma'))
        self.blocBtn.Bind(wx.EVT_BUTTON, self.OnBlocBtnButton,
              id=wxID_BLOCRESEAUBLOCBTN)

        self.staticTextLect = wx.StaticText(id=wxID_BLOCRESEAUSTATICTEXTLECT,
              label='Lecteurs r\xe9seaux', name='staticTextLect', parent=self,
              pos=wx.Point(488, 156), size=wx.Size(113, 16), style=0)
        self.staticTextLect.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD,
              False, 'Tahoma'))

    def __init__(self, parent, id, pos, size, style, name):
        self.drives_f = os.path.join(os.path.dirname(sys.executable), 'lecteurs.txt')
        self._init_ctrls(parent)
        self.init_interface__()

    def init_interface__(self):
        """initialise les combo et le bouton
        """
        self.blocBtn.Disable()
        self.choiceGrp.Clear()
        self.listCtrlUsers.DeleteAllItems()
        self.init_combo_time()
    
    def init_combo_time(self):
        """Affichage des limites de temps du blocage dans un format "humain"
        """
        self.hd = ( ('15 minutes', 15),
               ('30 minutes', 30),
               ('45 minutes', 45),
               ('1 heure', 60),
               ('1 heure 15', 75),
               ('1 heure 30', 90),
               ('1 heure 45', 105),
               ('2 heures', 120),
               ('2 heures 15', 135),
               ('2 heures 30', 150),
               ('2 heures 45', 165),
               ('3 heures', 180),
               ('4 heures', 240),
               ('1min', 1)
            )
        for i, j in self.hd:
            self.choiceEndBloc.Append(i, j)
        self.choiceEndBloc.SetSelection(0)

#########################
# Evnements graphiques #
#########################
    def OnChoiceGrpChoice(self, event):
        self.cur_groupe = self.choiceGrp.GetStringSelection()
        self.init_liste_eleves(self.cur_groupe)
        self.blocBtn.Enable()

    def OnBlocBtnButton(self, event):
        users = list()
        type = self.choiceTypeBloc.GetSelection()
        duree = self.choiceEndBloc.GetClientData(self.choiceEndBloc.GetSelection())
        partage = self.get_partage_mod()
        for eleve in self.ele_li:
            if self.listCtrlUsers.IsSelected(self.ele_li.index(eleve)):
                users.append((eleve, type, partage, duree))
        self.bloc_users(users)
##        # r-initialisation des listes/boutons radio ... en fait non, c'est pas pratique
##        self.choiceTypeBloc.SetSelection(0)
##        self.radioBtn0.SetValue(True)

    def get_partage_mod(self):
        drives = self.get_drives_perso()
        for i in range(3): #[self.radioBtn0, self.radioBtn1, self.radioBtn2]:
            if getattr(self, 'radioBtn%s'%i).GetValue() == True:
                break
        return (i, drives)
    
    def get_drives_perso(self):
        try: return file(self.drives_f).readline().strip().split(',')
        except: return None

    def utftoiso(self, label):
        try: return label.decode('utf-8').encode('iso8859-1')
        except: return label

###############################
# Gestion des appels distants #
###############################
    def init_combo_bloc(self, parent):
        # rcupration du parent
        self.parent = parent
        self.statusBar1 = self.parent.statusBar1
        # rcupration de la liste des groupes
        d = getrootobject()
        d.addCallback(lambda obj: obj.callRemote("get_bloc_list"))
        d.addCallback(self.return_blist)
        d.addErrback(self.serv_err,("Impossible de rcuprer la liste des types de blocages"))

    def return_blist(self, bd_list):
        disconnect()
        self.bloc_dict = bd_list
        for i in bd_list['reseau'].keys():
            self.choiceTypeBloc.Insert(bd_list['reseau'][i], i)
        self.choiceTypeBloc.SetSelection(0)
##        for i in bd_list['partages'].keys():
##            self.choiceBlocPart.Insert(bd_list['partages'][i], i)
##        self.choiceBlocPart.SetSelection(0)
        self.init_groupes()

    def init_groupes(self):
        """Appel  la mthode "remote_classes"
        """
        d = getrootobject()
        d.addCallback(lambda obj: obj.callRemote('classes_et_groupes'))
        d.addErrback(self.serv_err,("Rcupration de la liste des groupes impossible"))
        d.addCallback(self.return_groupes)
        
    def return_groupes(self, liste_groupes):
        """Affiche la liste des classes dans le premier comboBox
        """
        disconnect()
        if liste_groupes is None :
            fonctions.red_alert("Erreur lors de la rcupration de la liste des groupes")
            return
        self.groupes = liste_groupes
        self.groupes.append('eleves')
        self.choiceGrp.AppendItems(self.groupes)
        self.choiceGrp.Enable()
        self.choiceGrp.SetFocus()

    def init_liste_eleves(self, classe):
        """dclench lorsqu'une classe a t slectionne
        """
        # viter le 1er clic
        if classe == "":
            return
        # rcupration de la liste des connectes sur le serveur
        d = getrootobject()
        d.addCallback(lambda obj: obj.callRemote('users_bloc_mod', (classe)))
        d.addErrback(self.serv_err,("Rcupration de la liste des utilisateurs impossible"))
        d.addCallback(self.return_eleves)

    def return_eleves(self, bdict):
        """affiche le retour de la fonction "remote_users_bloc_mod(classe)"
        ou un message en cas d'erreur
        """
        disconnect()
        self.bdict = bdict
        self.init_eleves()
    
    def init_eleves(self):
        """affiche la liste des lves et leur type de blocage dans la listCtrl
        """
        self.listCtrlUsers.DeleteAllItems()
        if not self.bdict: return
        if len(self.bdict) == 0:
            self.listCtrlUsers.Append((u'Aucun lve trouv',''))
            return
        try:
##        if 1:
##            print self.bdict
            self.ele_li = self.bdict.keys()
            self.ele_li.sort()
            for eleve in self.ele_li:
                netmod = self.bdict[eleve]['netmod']
                partmod = self.bdict[eleve]['partmod'][0]
                bloclabel = self.bloc_dict['reseau'][netmod]
                partlabel = self.bloc_dict['partages'][partmod]
                self.listCtrlUsers.Append((eleve, self.utftoiso(bloclabel), self.utftoiso(partlabel)))
        except:
            self.listCtrlUsers.Append((u'Erreur', ''))
    
    def bloc_users(self, users):
        if len(users) > 1: msg = 'Application des blocages ...'
        else: msg = 'Application du blocage ...'
        self.statusBar1.SetStatusText(msg, 0)
        d = getrootobject()
        d.addCallback(lambda obj: obj.callRemote('set_user_bloc_mod', users))
        d.addErrback(self.serv_err,("Impossible d'appliquer le blocage"))
        d.addCallback(self.return_bloc_users)
    
    def return_bloc_users(self, ret):
        disconnect()
        self.init_liste_eleves(self.cur_groupe)
        self.statusBar1.SetStatusText('Pr\xeat', 0)

    def serv_err(self, ret, err):
        disconnect()
        err = 'Reseau : %s'%err
        if option.get_log_level() <= 10:
            try: err += '\n## %s'%ret.getBriefTraceback()
            except: err += '\n## %s'%ret
        fonctions.red_alert(err)
